/**************************************/
/*                                    */
/*  Prof. Dr. Carsten Vogt            */
/*  TH Koeln, Fakultaet IME           */
/*  http://www.nt.th-koeln.de/vogt    */
/*                                    */
/*  UNIX-C-Schnittstelle:             */
/*  Einfuehrendes Beispiel zu fork()  */
/*                                    */
/**************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main() {

 if (fork()==0) {

  /* Code des Sohns (Der Sohn laeuft im if-Teil
     weiter, da der Rueckgabewert von fork() fuer
     ihn 0 ist.) */
  sleep(4);

  printf("\nHier ist der Sohn\n");

  exit(0); /* Ende des Sohns (exit(0) darf nicht
              vergessen werden, da der Sohn-Prozess
              sonst im Code des Vaters weiterlaufen
              wuerde!) */
 }

 /* Code des Vaters (Der Vater laeuft nicht in den if-Teil,
    da der Rueckgabewert von fork() fuer ihn die PID des
    Sohns ist, deren Wert stets ungleich 0 ist.) */

 sleep(4);
 printf("\nHier ist der Vater\n\n");

}
