/****************************************/
/*                                      */
/*  Prof. Dr. Carsten Vogt              */
/*  TH Koeln, Fakultaet IME             */
/*  http://www.nt.th-koeln.de/vogt      */
/*                                      */
/*  UNIX-C-Schnittstelle:               */
/*  fork(): Feststellen der Vater- und  */
/*          Sohn-PIDs im Vater und im   */
/*          Sohn                        */
/*                                      */
/****************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main() {

  int sohn_pid;

  printf("\n");

  if ((sohn_pid=fork())==0) {
    /* sohn_pid speichert fuer den Vater die PID seines
       Sohns (= Rueckgabewert von fork()). Fuer den Sohn
       hat sohn_pid stets den Wert 0, ist also irrelevant. */ 

    printf("Sohn: Eigene PID ist %d\n",getpid());
    printf("Sohn: Vater-PID ist %d\n",getppid());
    exit(0);

  }

  sleep(1);
  printf("\n");
  printf("Vater: Eigene PID ist %d\n",getpid());
  printf("Vater: Sohn-PID ist %d\n\n",sohn_pid);

}