/**************************************/
/*                                    */
/*  Prof. Dr. Carsten Vogt            */
/*  TH Koeln, Fakultaet IME           */
/*  http://www.nt.th-koeln.de/vogt    */
/*                                    */
/*  UNIX-C-Schnittstelle:             */
/*  kill()                            */
/*                                    */
/**************************************/

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>

int main() {

  int sohn_pid, i=0;

  if ((sohn_pid=fork())==0) {

    /* Endlosschleife des Sohns mit Ausgabe
       einer Zahlenfolge. */
    while (1)
     printf("Sohn: %d\n",i++);

  }

  /* Vater wartet 2 Sekunden */
  sleep(2);

  /* Vater beendet den Sohn, indem er ihm das
     Signal SIGKILL schickt. */
  printf(">>>> Vater schickt SIGKILL an den Sohn\n");
  kill(sohn_pid,SIGKILL); 

}