/******************************************/
/*                                        */
/*  Prof. Dr. Carsten Vogt                */
/*  TH Koeln, Fakultaet IME               */
/*  http://www.nt.th-koeln.de/vogt        */
/*                                        */
/*  UNIX-C-Schnittstelle:                 */
/*  Prozesskommunikation ueber            */
/*  benannte Pipes                        */
/*  Hier: Senderprozess;                  */
/*  Empfaengerprozess in pipe_ben_2.c     */
/*  (Erst den Senderprozess im Hinter-    */
/*   grund starten, dann den Empfaenger-  */
/*   prozess.)                            */
/*                                        */
/******************************************/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>

int main() {

 int fd; /* Deskriptor fr die Pipe */

 /* Erzeugen einer benannten Pipe namens PIPE_1 */

 printf("\nProzess 1 erzeugt die benannte Pipe PIPE_1\n");

 mkfifo("PIPE_1",0666);

 /* ffnen der Pipe zum Schreiben */

 printf("\nProzess 1 oeffnet die Pipe zum Schreiben\n");

 fd=open("PIPE_1",O_WRONLY);

 /* Schreiben in die Pipe */

 // Version 1: Nur eine Schreiboperation

 printf("\nProzess 1 schreibt TEST in die Pipe\n");

 write(fd,"TEST",5);

 // Version 2: Zwei Teiltexte mit Zeitverzoegerung schreiben - der Empfaenger liest nur den ersten aus, selbst wenn er im read() alle Bytes empfangen koennte!

// printf("\nProzess 1 schreibt TE in die Pipe\n");

// write(fd,"TE",2);

// sleep(2);

// printf("\nProzess 1 schreibt ST in die Pipe\n");

// write(fd,"ST",3);

}