/******************************************/
/*                                        */
/*  Prof. Dr. Carsten Vogt                */
/*  TH Koeln, Fakultaet IME               */
/*  http://www.nt.th-koeln.de/vogt        */
/*                                        */
/*  UNIX-C-Schnittstelle:                 */
/*  Prozesskommunikation ueber            */
/*  benannte Pipes                        */
/*                                        */
/*  Hier: Empfaengerprozess;              */
/*   Senderprozess in pipe_ben_2.c        */
/*  (Erst den Senderprozess im Hinter-    */
/*   grund starten, dann den Empfaenger-  */
/*   prozess.)                            */
/*                                        */
/******************************************/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>

int main() {

 char buffer[5];

 int fd;

 /* Oeffnen der Pipe zum Lesen */

 printf("\nProzess 2 oeffnet die Pipe zum Lesen\n");

 fd=open("PIPE_1",O_RDONLY);

 /* Lesen aus der Pipe */

 read(fd,buffer,5);

 printf("\nProzess 2 liest %s aus der Pipe\n",buffer);

 /* Loeschen der Pipe */

 printf("\nProzess 2 loescht die Pipe\n\n");

 unlink("PIPE_1");

}